'************ PWM load.BAS ******************
'********* Jure Mikeln, July 2011 ***********
'********* Copyright AX elektronika *********



$regfile = "attiny45.dat"
'$regfile = "m16def.dat"

$hwstack = 28
$swstack = 28
$framesize = 28

Const Test = 1


$crystal = 8000000


Dim En_lcd As Byte                                          'Enable LCD as byte
Dim N As Byte , M As Byte

#if Test = 0                                                'if Test=0 then use Mega16, else Tiny45


'Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Down , Prescale = 1       'not needed with ATTiny45
Const Lcdport = Porta                                       'LCD on PortA
Config Spi = Soft , Din = Pina.3 , Dout = Porta.4 , Clock = Porta.5 , Ss = None

#else


Const Lcdport = Portb                                       'LCD on PortB
Tccr1 = &B00000001
Gtccr = &B01100000
Config Spi = Soft , Din = Pinb.3 , Dout = Portb.2 , Clock = Portb.0 , Ss = None

#endif


Enable Timer1
Enable Interrupts

$lib "lcd-spi.lib"                                          'SPI library used
Const Lcd_e = 3                                             'Enable pin


Config Lcd = 16 * 2

Initlcd                                                     'at start initiallize LCD
Cls

Do


Config Portb.4 = Output                                     'PWM output
Portb.4 = 0


Portb.1 = 1
Portb.3 = 1

Config Portb.1 = Input                                      'keypad SW2
Config Portb.3 = Input                                      'keypad SW1


If Pinb.1 = 0 Then
   Gosub Up_sub
   Waitms 50
End If

If Pinb.3 = 0 Then
   Gosub Down_sub
   Waitms 50
End If

Ocr1a = N
Ocr1b = N


En_lcd = 3 : Initlcd
Cursor Off
Upperline
Lcd "PWM= " ; N ; "                          "              'display on LCD

Waitms 80

Loop
End


Up_sub:
Incr N
Return

Down_sub:
Decr N
Return